;;; perldoc-view-mode.el --- use view-mode in perldoc.el buffers

;; Copyright 2009, 2011, 2014 Kevin Ryde

;; Author: Kevin Ryde <user42_kevin@yahoo.com.au>
;; Version: 0
;; Keywords: languages, perl
;; URL: http://user42.tuxfamily.org/perldoc-view-mode/index.html

;; emacs-lisp-docstring-preview.el is free software; you can redistribute it
;; and/or modify it under the terms of the GNU General Public License as
;; published by the Free Software Foundation; either version 3, or (at your
;; option) any later version.
;;
;; emacs-lisp-docstring-preview.el is distributed in the hope that it will be
;; useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You can get a copy of the GNU General Public License online at
;; <http://www.gnu.org/licenses/>.



;;; Commentary:
;; 

;;; Code:

(defadvice perldoc-sentinel (after perldoc-view-mode activate)
  "Use `view-mode' in *Perldoc* buffer."
  (if (get-buffer "*Perldoc*") ;; doesn't exist if lookup failed
      (with-current-buffer "*Perldoc*"
        (view-mode))))

;; LocalWords: Perldoc

(provide 'perldoc-view-mode)

;;; perldoc-view-mode.el ends here
