;; Copyright 2008, 2009, 2010, 2012, 2014 Kevin Ryde.      -*- coding: latin-1 -*-

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



;;-----------------------------------------------------------------------------

(require 'ffap-perl-module)
;; (debug-on-entry 'ffap-string-at-point)
List::Util
(ffap-url-at-point)
(ffap-guesser)
~/lisp/ffap-perl-module.el

;;-----------------------------------------------------------------------------

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (eval-after-load "ffap" '(require 'ffap-perl-module))
  (global-set-key "\C-c\C-f" 'find-file-at-point))

(require 'ffap)
(require 'ffap-perl-module)
(unload-feature 'ffap-perl-module)
(require 'ffap-makefile-vars)
(require 'ffap-mml)
(require 'ffap-href)
ffap-string-at-point
substitute-in-file-name

(progn
  (setq ffap-perl-module-path nil)
  (ffap-perl-module-path))

ffap $Perl::Critic::Pulp::Utils::COMMA{$elem});
my-autoloads.el
Data::Dumper
Data::Dumper::Sub
Data::Dumper::sub()
Data::Dumper::Some::Deep::sub()
\&Data::Dumper::Some::Deep::sub
$ Data::Dumper::Sortkeys
Symbol
Symbol.txt
/Symbol
sort.el
use sort;
$sort::setting
Moose::Cookbook
MooseX::Types
FindBin::Script
DNS
Client::DNS
use FindBin;
require # fjdks
# fjdks
FindBin;
no FindBin;
$FindBin::sat;
$HOME
$HOME/lisp
${NOSUCH}/lisp
${HOME}
use FindBin;

(substitute-in-file-name "${NOSUCH")
(substitute-in-file-name "${NOSUCH]}")
(substitute-in-file-name "$NOSUCH}")
(substitute-in-file-name "$NOSUCH]")
(substitute-in-file-name "${NOSUCH}/lisp")
(substitute-in-file-name "$NOSUCH/lisp")
(substitute-in-file-name "$}")
(substitute-in-file-name "$X}")

(customize-group 'ffap)
(customize-variable 'ffap-perl-module-path)
ffap-perl-module-qualif-regexp

(let ((default-directory "/home/gg"))
  (switch-to-buffer "x")
  (ffap-perl-module-expand-prefix "ProhibitHardTabs"))
(progn
  (switch-to-buffer "x")
  (ffap-perl-module-expand-prefix "DNS"))

(pp ffap-perl-module-path (current-buffer))

(elp-instrument-package "ffap-perl-module-")

(progn
  (thing-at-point-looking-at
   "\\\\*[$@%&]\\s-*\\([[:alpha:]_][[:alnum:]_]*\\(::[[:alpha:]_][[:alnum:]_]*\\)*\\)")
  (match-end 1))
$HOME/.gnupg/gpg-agent-info

;;-----------------------------------------------------------------------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))
(progn
  (elint-initialize)
  (find-file "../ffap-perl-module.el")
  (elint-current-buffer))

;;-----------------------------------------------------------------------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../ffap-perl-module.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))


;;-----------------------------------------------------------------------------
;; ffap-perl-module-expand-prefix
;; skips /auto
(progn
  (make-directory "/tmp/lib/auto/pack/" t)
  (make-directory "/tmp/lib/pack/" t)
  (with-temp-buffer (insert "hello\n")
                    (write-file "/tmp/lib/auto/pack/foo.pm"))
  (with-temp-buffer (insert "world\n")
                    (write-file "/tmp/lib/pack/bar.pm")))

(let ((ffap-perl-module-path '("/tmp/lib")))
  (ffap-perl-module-expand-prefix "bar"))
(let ((ffap-perl-module-path '("/tmp/lib")))
  (ffap-perl-module-expand-prefix "foo"))


;;-----------------------------------------------------------------------------

(let ((count 0))
  (add-to-list 'load-path (expand-file-name ".."))

  (require 'ffap-perl-module)
  (require 'ffap)

  (let ((default-directory "/no/such/dir")
        (ffap-perl-module-path nil))
    (ffap-perl-module-path)
    (or (equal default-directory "/no/such/dir")
        (error "oops, default-directory changed"))
    (setq count (1+ count)))

  (dolist (elem '(("use sort;"      "/usr/share/perl/5.10/sort.pm")
                  ("require sort"   "/usr/share/perl/5.10/sort.pm")
                  ("$sort::setting" "/usr/share/perl/5.10/sort.pm")
                  ("DNS" nil)
                  ("$ProhibitHardTabs::VERSION" nil)
                  ("$Perl::Critic::Policy::CodeLayout::ProhibitHardTabs::VERSION"
                   "/down/pc/perlcritic/distributions/Perl-Critic/lib/Perl/Critic/Policy/CodeLayout/ProhibitHardTabs.pm")
                  ("\\$FindBin::Script"  "/usr/share/perl/5.10/FindBin.pm")
                  ("@ \nFindBin::Script" "/usr/share/perl/5.10/FindBin.pm")
                  ("PoCo::Client::DNS"
                   "/usr/share/perl5/POE/Component/Client/DNS.pm")
                  ("$Module::Build::Compat"
                   "/usr/share/perl5/Module/Build.pm")
                  ("$FOO" nil)))
    (let* ((shorten 0)
           (str  (nth 0 elem))
           (want (nth 1 elem)))
      (with-temp-buffer
        (insert str)
        (goto-char (point-min))
        (let ((got (ffap-perl-module-file-at-point)))
          (unless (equal want got)
            (error "ffap-perl-module-file-at-point str %S got %S want %S\n"
                   str got want))
          (setq count (1+ count))))))

  (dolist (elem '(("FindBin::Script" "/usr/share/perl/5.10/FindBin.pm")
                  ("FindBin"         "/usr/share/perl/5.10/FindBin.pm")
                  ("Net::DNS::foo::bar" "/usr/lib/perl5/Net/DNS.pm")))
    (let* ((shorten 0)
           (str  (nth 0 elem))
           (want (nth 1 elem))
           (got  (ffap-perl-module-prune-suffix str)))
      (unless (equal want got)
        (error "prune-suffix str %S got %S want %S\n" str got want))
      (setq count (1+ count))))

  (dolist (elem '(("DNS" nil)
                  ("ProhibitHardTabs"
                   "/down/pc/perlcritic/distributions/Perl-Critic/lib/Perl/Critic/Policy/CodeLayout/ProhibitHardTabs.pm")
                  ("Client::DNS"
                   "/usr/share/perl5/POE/Component/Client/DNS.pm")))
    (let* ((shorten 0)
           (str  (nth 0 elem))
           (want (nth 1 elem))
           (got  (ffap-perl-module-expand-prefix str)))
      (unless (equal want got)
        (error "expand-prefix str %S got %S want %S\n" str got want))
      (setq count (1+ count))))

  count)

;;-----------------------------------------------------------------------------

(equal (propertize "x" 'face 'bold) "x")

FindBin::Script
FindBin::Script::fjksd::fsdjk
ProhibitReturnSort
CodeLayout::ProhibitHardTabs
(progn
  (switch-to-buffer "x")
  (dolist (dir (ffap-perl-module-path))
    (call-process "find" nil t nil
                  dir "!" "-name" "*.*")))





(let ((default-directory "/etc"))
  (file-exists-p "passwd"))

(let ((default-directory "/etc"))
  (directory-files
   "" t
   "\\`[[:alpha:]_][[:alnum:]_]*\\'"
   t))


(defun my-perl-find-library-ffap (name)
  "Return perl module filename for ffap.
NAME is currently ignored, since ffap will take \":\" to be
`path-separator', so a fresh `ffap-string-at-point' gives the
module name.

The return is a filename if the module at point is known, or nil
if not."
  (perl-library-path (ffap-string-at-point)))

(eval-after-load "ffap"
  '(progn
     ;; (add-to-list 'ffap-alist  '(cperl-mode . my-perl-find-library-ffap))
     (add-to-list 'ffap-alist  '("::" . my-perl-find-library-ffap))
     (add-to-list 'ffap-string-at-point-mode-alist
                  '(cperl-mode "A-Za-z0-9_:" "" ":"))))
;; (add-to-list 'ffap-alist  '("\\`[A-Z].*::" . my-perl-find-library-ffap))


(defun my-cperl-ffap-locate(name)
  "Return cperl module for ffap"
  (let* ((r (replace-regexp-in-string ":" "/" (file-name-sans-extension name)))
         (e (replace-regexp-in-string "//" "/" r))
         (x (ffap-locate-file e '(".pm" ".pl" ".xs")
                              (append (ffap-all-subdirs-loop "/usr/lib/perl5/site_perl/5.8.5/" -1)
                                      (ffap-all-subdirs-loop "/usr/local/lib/perl5/site_perl/5.8.5/" -1)))))
    x
    )
  )
   (add-to-list 'ffap-alist  '(cperl-mode . my-cperl-ffap-locate))

;; Emacs::PDE





;; from wiki

(defun my-cperl-ffap-locate (name)
  "Return cperl module for ffap"
  (let* ((r (replace-regexp-in-string ":" "/" (file-name-sans-extension name)))
         (e (replace-regexp-in-string "//" "/" r))
         (x (ffap-locate-file
             e '(".pm" ".pl" ".xs")
             (append (ffap-all-subdirs-loop "/usr/share/perl5" -1)
                     (ffap-all-subdirs-loop "/usr/share/perl/5.10" -1)))))
    x))
 
(add-to-list 'ffap-alist  '(cperl-mode . my-cperl-ffap-locate))


;; (defvar ffap-perl-inc-dirs
;;   (apply 'append
;;          (mapcar (function ffap-all-subdirs)
;;                  (split-string (shell-command-to-string
;;                                 "perl -e 'pop @INC; print join(q/ /,@INC);'")))))
;; 
;; (defun my-cperl-ffap-locate(name)
;;   "Return cperl module for ffap"
;;   (let* ((r (replace-regexp-in-string ":" "/"       (file-name-sans-extension name)))
;;          (e (replace-regexp-in-string "//" "/" r))
;;          (x (ffap-locate-file e '(".pm" ".pl" ".xs") ffap-perl-inc-dirs)))
;;     x))







;; 
;; 
;; 			
;; and then
;; 
;; 
;; 
;; Finding Perl modules
;; 
;; As an alternative to the ffap version above, the following will find a given Perl module, using perl's internal lookup to find the module:
;; 
;; (defun perl-module-path (module-name)
;;   (let* ((file-name
;;           (concat (replace-regexp-in-string "::" "/" module-name)
;;                   ".pm"))
;;          (command-line
;;           (concat "perl -M'"
;;                   module-name
;;                   "' -e'print $INC{q{"
;;                   file-name
;;                   "}}'"))
;;          (path (shell-command-to-string command-line))
;;          (cant-locate (string-match "^Can't locate " path)))
;;     (if cant-locate
;;         nil
;;       path)))
;; 
;; (defun find-perl-module (module-name)
;;   (interactive "sPerl module name: ")
;;   (let ((path (perl-module-path module-name)))
;;     (if path
;;         (find-file path)
;;       (error "Module '%s' not found" module-name))))


