;; Copyright 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; Maybe:
;; 	- makeinfo - parse of @math{}
;; 	- dbtexmath unescape()
;; 	- amsmath
;; 		\begin{equation} ... \end{equation}
;; 		\begin{gather} ... \end{gather}
;; 		\begin{align} ... \end{align}
;; 		\begin{alignat} ... \end{alignat}


;;-----------------
;; call-process stderr

(call-process "sh"
              nil ;; in
              nil ;; out
              nil ;; redisplay
              "-c"
              "cat --no-such-arg")

;;-----------------

(unless (fboundp 'derived-mode-p)
  (defun derived-mode-p (mode)
    nil));; emacs20

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (autoload 'tex-math-preview "tex-math-preview" nil t)

  (define-key global-map [f8] 'tex-math-preview)
  (setq tex-dvi-view-command "my-zgv-dvi"))

(thing-at-point 'tex-math)
(tex-math-preview-bounds-of-tex-math)

(fmakunbound 'image-mode)
(auto-image-file-mode)

;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;-----------------
http://thewe.net/tex/
http://www.codecogs.com/latex/eqneditor.php

[; e^{\pi i} + 1 = 0 ;]
[; \frac{1}{2} ;]

;;-----------------

\begin{align*}
2x^2 + 3(x-1)(x-2) & = 2x^2 + 3(x^2-3x+2)\\
&= 2x^2 + 3x^2 - 9x + 6\\
&= 5x^2 - 9x + 6
\end{align*}

\begin{align}
a+b&=c
\end{align}

\begin{math}
a+b  =c
\end{math}


\begin{equation}
\label{eq:ising}
\Delta =\sum_{i=1}^N w_i (x_i - \bar{x})^2 .
\end{equation}
\begin{equation}
P(x) = \frac{x - a}{b - a} , \nonumber
\end{equation}

$1\over2$
$\frac{1}{2}$

<alt role="tex">
  \[F_{2,T-k}=\frac{(ESS_r-ESS_u)/2}{ESS_u/(T-k)}\]
</alt>

$
 1
 +
 2
%% blah
+ 3
$

<alt role="tex">$C = \alpha + \beta Y^{\gamma} + \epsilon$</alt>

$$ zzz $$

$$ foo $$

$$ bar $$


$ zzz $

$ foo $

$ bar $


$\int$


@math{ 999}
@math{ 1 + 2 + 3}
@math{ 456}

<math> 999 </math>




<math> 1 + 2 + 3 </math>
<math> 456 </math>

$$ 999 $$
$$ 1 + 2 + 3 $$
$$ 456 $$


<math>

1 + 2 + 3

</math>


@math{

1 + 2 + 3

}

$

1 + 2 + 3

$

$$
 \$\$\$1 + \$2 + \$3 
$$







\\|\
<alt role=\"tex\">\\(\\(?:.\\|\n\\)*?\\)</alt>

((match-beginning 3)
                       (cons (match-beginning 3) (match-end 3)))
                      (t
                       (cons (match-beginning 4) (match-end 4)))


;;-----------------------------------------------------------------------------
;; emacs20 

(progn
  (require 'poe)
  (defun replace-regexp-in-string (regexp rep string
					  &optional fixedcase literal
					  ;; subexp start
					  )
    (with-temp-buffer
      (insert string)
      (goto-char (point-min))
      (while (re-search-forward regexp nil t)
	(replace-match rep fixedcase literal nil subexp))
      (buffer-string)))
  (defun derived-mode-p (target)
    (let ((mode major-mode))
      (while (and (not (eq mode target))
		  (setq mode (get mode 'derived-mode-parent))))
      mode)))
$1\over2$

(setq debug-on-error t)
(defun image-type-available-p (type)
  nil)
(derived-mode-p 'fundamental-mode)
(derived-mode-p 'emacs-lisp-mode)


;;-----------------
;; backref

(string-match "\\(ab\\)\\1"
              "abab")

(string-match "\\\\begin{\\(math\\)}\\(\\(.\\|\n\\)*?\\)\\\\end{\\1}"
              "\\begin{math} blah \\end{xmath}")
