;; Copyright 2014, 2015 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; Look for non-ascii characters in docstrings.
;; Including unescaped \r or \M-x.

;; \x09 tab
;; \x0A linefeed
;; \x0C formfeed
(setq my-docstring-nonascii-regexp "[\x00-\x08\x0B\x0D-\x1F\x7F-\xFFFF]")
(string-match my-docstring-nonascii-regexp "F")
"\x09"

(defun my-hex-string (str)
  (let ((ret ""))
    (dotimes (i (length str))
      (setq ret (concat ret " "
                        (format " %02X" (aref str i)))))
    ret))

(defun my-docstring-nonascii ()
  (interactive)

  (require 'info-xref)
  (pop-to-buffer info-xref-output-buffer t)
  (let ((info-xref-filename-heading "")
	(case-fold-search t))

    (info-xref-output "Checking docstring non-ascii ...\n")
    (with-temp-buffer
      (mapatoms
       (lambda (symbol)
         (let ((str (condition-case nil
                        (documentation symbol
                                       t) ;; raw
                      (error nil))))
           (when str
             (erase-buffer)
             (insert str)
             (goto-char (point-min))
             (while (re-search-forward my-docstring-nonascii-regexp nil t)
               (info-xref-output "%s\n  %s\n"
                                 symbol
                                 (my-hex-string (match-string 0)))))))))
    (info-xref-output "done\n")))

;; (load (expand-file-name "my-load-all.el"))
;; (my-load-all--autoloads)
(my-docstring-nonascii)




(string-match "[[:cntrl:]]" "\r")
