;; not working, doubtful merit now


;;; cdbs-simple-patchsys.el --- run cdbs-edit-patch from within Emacs

;; Copyright 2010, 2013, 2015, 2016 Kevin Ryde

;; Author: Kevin Ryde <user42_kevin@yahoo.com.au>
;; Version: 0
;; Keywords: data, cdbs
;; URL: http://user42.tuxfamily.org/cdbs-simple-patchsys/index.html

;; cdbs-simple-patchsys.el is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as published
;; by the Free Software Foundation; either version 3, or (at your option)
;; any later version.
;;
;; cdbs-simple-patchsys.el is distributed in the hope that it will be
;; useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You can get a copy of the GNU General Public License online at
;; <http://www.gnu.org/licenses/>.


;;; Commentary:
;; 

(require 'lisp-mnt)

;;; Code:

(defvar cdbs-edit-patch-directory nil)
(make-variable-buffer-local 'cdbs-edit-patch-directory)

(defvar cdbs-edit-patch-filename nil)
(make-variable-buffer-local 'cdbs-edit-patch-directory)

;; (defun cdbs-edit-patch-sentinel (process state)
;;   (message "cdbs-edit-patch done: %s" state))

;;;###autoload
(defun cdbs-edit-patch (filename)
  (interactive
   (let ((default (and buffer-file-name
                       (let ((case-fold-search nil))
                         (string-match "/debian/patch/\\([^/]+\\)"
                                       buffer-file-name))
                       (match-string 1 buffer-file-name))))
     (list (read-file-name (if default
                               (format "Patch file to edit (%s)" default)
                             "Patch file to edit")
                           nil
                           default))))

  (unless (string-match "\\(\\(.\\|\n\\)*/\\)debian/patches/" filename)
    (error "Not a .../debian/patches/ filename"))
  (let ((filename-patch     (substring filename (match-end 1)))
        (filename-directory (match-string 1 filename))
        (filename-truename  (file-truename filename)))

    (save-some-buffers nil (lambda ()
                             (and buffer-file-name
                                  (equal (file-truename buffer-file-name)
                                         filename-truename))))

    (switch-to-buffer (format "*cdbs-edit-patch* %s" filename))
    (setq default-directory filename-directory)
    (setq cdbs-edit-patch-filename filename-patch)
    (insert filename "\n" filename-directory "\n" filename-patch "\n")

    (let* ((process
            (let ((process-connection-type 'pty))
              (start-process "cdbs-edit-patch"
                             (current-buffer)
                             "cdbs-edit-patch"
                             cdbs-edit-patch-filename))))
      ;; (set-process-sentinel process 'cdbs-edit-patch-sentinel)
      (process-send-string nil "echo newdir; pwd\n")

      (while (not (save-excursion
                    (re-search-backward "^\\(/tmp/[^ \t\r\n]+\\)\n" nil t)))
        (redisplay t)
        (accept-process-output process)
        (unless (eq 'run (process-status nil))
          (error "\"cdbs-edit-patch\" error")))

      (setq cdbs-edit-patch-directory (match-string 1))
      (find-file cdbs-edit-patch-directory)

      (let ((first-file
             (lm-with-file filename-truename
               (save-excursion
                 (goto-char (point-min))
                 (and (re-search-forward "^--- [^/]*/+\\([^\t\r\n]+\\)" nil t)
                      (match-string 1))))))
        (if first-file
            (find-file first-file)))

      (message "Patched temp dir %s, %s to save or %s to abort"
               cdbs-edit-patch-directory
               (substitute-command-keys "\\[cdbs-edit-patch-done]")
               (substitute-command-keys "\\[cdbs-edit-patch-abort]")))))

(defun cdbs-edit-patch-done ()
  (interactive)
  (with-current-buffer (cdbs-edit-patch-find-buffer)
    (cdbs-edit-patch-save-buffers)
    (cdbs-edit-patch-kill-buffers)

    (process-send-eof nil)
    (while (eq 'run (process-status nil))
      (accept-process-output (get-buffer-process (current-buffer))))

    (let ((buffer (find-buffer-visiting cdbs-edit-patch-filename)))
      (when buffer
        (with-current-buffer buffer
          (revert-buffer))))

    (when (eq 'exit (process-status nil))
      (kill-buffer nil))))

(defun cdbs-edit-patch-abort ()
  (interactive)
  (with-current-buffer (cdbs-edit-patch-find-buffer)
    (cdbs-edit-patch-kill-buffers)
    (process-send-string nil "exit 1\n")))
;; '(kill-process (get-buffer-process (current-buffer)))

(defun cdbs-edit-patch-find-buffer ()
  (catch 'cdbs-edit-patch-find-buffer
    (let (cdbs-buffers)
      (dolist (buffer (buffer-list))
        (when (buffer-live-p buffer)
          (let ((dir (with-current-buffer buffer
                       cdbs-edit-patch-directory)))
            (when dir
              (if (string-match (concat "\\`" (regexp-quote dir)) buffer-file-name)
                  (throw 'cdbs-edit-patch-find-buffer buffer))
              (push buffer cdbs-buffers)))))
      (if (= 1 (length cdbs-buffers))
          (car cdbs-buffers)
        (error "More than one patch currently being edited, call from under the temp dir")))))

(defun cdbs-edit-patch-kill-buffers ()
  (let* ((regexp (concat "\\`" (regexp-quote cdbs-edit-patch-directory))))
    (dolist (buffer (buffer-list))
      (when (buffer-live-p buffer)
        (with-current-buffer buffer
          (when (or (and buffer-file-name
                         (string-match regexp buffer-file-name))
                    (and (eq major-mode 'dired-mode)
                         (string-match regexp default-directory)))
            (kill-buffer buffer)))))))

(defun cdbs-edit-patch-save-buffers ()
  (let ((regexp (concat "\\`" (regexp-quote cdbs-edit-patch-directory))))
    (save-some-buffers nil (lambda ()
                   (and buffer-file-name
                        (string-match regexp buffer-file-name))))))

;; (cdbs-edit-patch
;;  (expand-file-name "~/lisp/edit-patch/Tie-TZ-7/debian/patches/foo.patch"))

;; LocalWords: debian filename dir

(provide 'cdbs-simple-patchsys)

;;; cdbs-simple-patchsys.el ends here
